//+------------------------------------------------------------------+
//|                                             +PriceSR_filter+.mq4 |
//|                                   # Price in Sup. or Res. ZONE # |
//|                                        Copyright  2008, masemus |
//|                                    Gresik - EastJAVA - Indonesia |
//+------------------------------------------------------------------+
#property copyright "masemus"
#property link      "masemus@yahoo.com"

#property indicator_separate_window
#property indicator_maximum 1
#property indicator_minimum 0
#property indicator_buffers 8
#property indicator_color1 GreenYellow
#property indicator_color2 LightGreen
#property indicator_color3 LimeGreen
#property indicator_color4 SeaGreen
#property indicator_color5 Yellow
#property indicator_color6 Gold
#property indicator_color7 Orange
#property indicator_color8 OrangeRed

#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 5
#property indicator_width5 5
#property indicator_width6 5
#property indicator_width7 5
#property indicator_width8 5

extern int TF = 0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];

string MTF="";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators
  SetIndexStyle(0,DRAW_HISTOGRAM);
  SetIndexBuffer(0,ExtMapBuffer1);
  SetIndexStyle(1,DRAW_HISTOGRAM);
  SetIndexBuffer(1,ExtMapBuffer2);
  SetIndexStyle(2,DRAW_HISTOGRAM);
  SetIndexBuffer(2,ExtMapBuffer3);
  SetIndexStyle(3,DRAW_HISTOGRAM);
  SetIndexBuffer(3,ExtMapBuffer4);
  SetIndexStyle(4,DRAW_HISTOGRAM);
  SetIndexBuffer(4,ExtMapBuffer5);
  SetIndexStyle(5,DRAW_HISTOGRAM);
  SetIndexBuffer(5,ExtMapBuffer6);
  SetIndexStyle(6,DRAW_HISTOGRAM);
  SetIndexBuffer(6,ExtMapBuffer7);
  SetIndexStyle(7,DRAW_HISTOGRAM);
  SetIndexBuffer(7,ExtMapBuffer8);

  SetIndexLabel(0,NULL);
  SetIndexLabel(1,NULL);
  SetIndexLabel(2,NULL);
  SetIndexLabel(3,NULL);
  SetIndexLabel(4,NULL);
  SetIndexLabel(5,NULL);
  SetIndexLabel(6,NULL);
  SetIndexLabel(7,NULL);

//+------------------------------------------------------------------+
   double cTF=Period();

               if (cTF==PERIOD_M1) { MTF="M 1"; }
               if (cTF==PERIOD_M5) { MTF="M 5"; }
               if (cTF==PERIOD_M15) { MTF="M15"; }
               if (cTF==PERIOD_M30) { MTF="M30"; }
               if (cTF==PERIOD_H1) { MTF="H 1"; }
               if (cTF==PERIOD_H4) { MTF="H 4"; }
               if (cTF==PERIOD_D1) { MTF="D 1"; }
               if (cTF==PERIOD_W1) { MTF="W 1"; }
               if (cTF==PERIOD_MN1) { MTF="MN1"; }

               else if (TF == 1) { MTF="M 1"; }
               else if (TF == 5) { MTF="M 5"; }
               else if (TF == 15) { MTF="M15"; }
               else if (TF == 30) { MTF="M30"; }
               else if (TF == 60) { MTF="H 1"; }
               else if (TF == 240) { MTF="H 4"; }
               else if (TF == 1440) { MTF="D 1"; }
               else if (TF == 10080) { MTF="W 1"; }
               else if (TF == 43200) { MTF="MN1"; }

   IndicatorShortName("+PriceSR+ "+MTF+"");  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int      i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
  
     limit = Bars-counted_bars;

   for( i=limit; i>=0; i--)
   {
   
   ExtMapBuffer1[i]=0.0;
   ExtMapBuffer2[i]=0.0;
   ExtMapBuffer3[i]=0.0;
   ExtMapBuffer4[i]=0.0;
   ExtMapBuffer5[i]=0.0;
   ExtMapBuffer6[i]=0.0;
   ExtMapBuffer7[i]=0.0;
   ExtMapBuffer8[i]=0.0;
 
   //Price
   double Harga = iMA(Symbol(),TF,1,0,MODE_EMA,PRICE_CLOSE,i);   
   double pHarga = iMA(Symbol(),TF,1,0,MODE_EMA,PRICE_CLOSE,i+1);   
   double Open_o = iOpen(NULL,TF,i);
   double or = iHigh(NULL,TF,i+1) - iLow(NULL,TF,i+1);
   double oR = (iHigh(NULL,TF,i+1) + iLow(NULL,TF,i+1))/2;
   double oP = (iHigh(NULL,TF,i+1) + iLow(NULL,TF,i+1) + iClose(NULL,TF,i+1))/3;
   double Midnol = (Open_o + oP)/2;

   //Market
   double UPzone1 = oP + (or * 0.236);
   double UPzone2 = oP + (or * 0.618);
   double UPzone3 = oP + (or * 1.236);
   double DNzone1 = oP - (or * 0.236);
   double DNzone2 = oP - (or * 0.618);
   double DNzone3 = oP - (or * 1.236);
  
     if ((Harga >= Midnol) && (Harga < UPzone1)) {ExtMapBuffer1[i]=1;}
     if ((Harga >= UPzone1) && (Harga < UPzone2)) {ExtMapBuffer2[i]=1;}
     if ((Harga >= UPzone2) && (Harga < UPzone3)) {ExtMapBuffer3[i]=1;}
     if (Harga >= UPzone3) {ExtMapBuffer4[i]=1;}
     if ((Harga < Midnol) && (Harga > DNzone1)) {ExtMapBuffer5[i]=1;}
     if ((Harga <= DNzone1) && (Harga > DNzone2)) {ExtMapBuffer6[i]=1;}
     if ((Harga <= DNzone2) && (Harga > DNzone3)) {ExtMapBuffer7[i]=1;}
     if (Harga <= DNzone3) {ExtMapBuffer8[i]=1;}

   }



//----
   return(0);
  }
//+------------------------------------------------------------------+

